package model;

import java.io.DataInputStream;
import java.io.IOException;

public class Alarm implements Comparable<Alarm>, Operable {
    private String name;
    private Time time;
    public Alarm() {
    	name = null;
    	time = null;
    }
    public Alarm(String name, String time)
    throws BadHourException, BadMinuteException, BadFormatException {
        this.name = name;
        this.time = new Time(time);
    }
    public String getName() {
        return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public Time getTime() {
		return time;
	}
	public void setTime(String time)
    throws BadHourException, BadMinuteException, BadFormatException {
		this.time = new Time(time);
	}
	public String toString() {
		return time + " : " + name;
	}
	public int compareTo(Alarm o) {
		int resultForTimes = time.compareTo(o.time);
		if (resultForTimes == 0)
			return name.compareTo(o.name);
		return resultForTimes;
	}
	public void loadFrom(DataInputStream s) throws IOException {
		time = new Time();
		time.loadFrom(s);
		name = s.readUTF();
	}
	public void performs(Operation op) throws Exception {
		op.doItOn(this);
	}
}
