package model;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public abstract class Clock {
	static int HOURS_PER_DAY = 24;
	static int MINUTES_PER_HOUR = 60;
	protected int h;
	protected int m;
	protected Clock() { }
	protected Clock(int h, int m) {
		this.h = h;
		this.m = m;
	}
	public int hour() {
		return h;
	}
	public int minute() {
		return m;
	}
	public void oneMinuteMore() {
		m = (m + 1) % MINUTES_PER_HOUR;
		if (m == 0) oneHourMore();
	}
	public abstract void oneHourMore();
	public abstract void oneHourLess() throws Exception;
	public abstract void oneMinuteLess() throws Exception;
	public abstract String toString();
	public void saveInto(DataOutputStream s) throws IOException {
		s.writeByte((byte)h);
		s.writeByte((byte)m);
	}
	public void loadFrom(DataInputStream s) throws IOException {
		h = s.readByte();
		m = s.readByte();
	}
}
