package model;

import java.io.DataOutputStream;

public class SaveBinary implements Operation {
	private DataOutputStream s;
	public SaveBinary(DataOutputStream s) {
		this.s = s;
	}
	public void doItOn(AlarmList l) throws Exception {
		s.writeInt(l.size());
		for(Alarm a : l) { doItOn(a); }
	}
	public void doItOn(Alarm a) throws Exception {
		doItOn(a.getTime());
		s.writeUTF(a.getName());
	}
	public void doItOn(Time t) throws Exception {
		s.writeByte((byte)(t.hour()));
		s.writeByte((byte)(t.minute()));
	}
}
